\name{kdesign.cov}
\alias{kdesign.cov}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{ Covariance matrix}
\description{
  This function generates a covariance matrix either using both point
  and eligible object or only using the point object.
}
\usage{
kdesign.cov(point.obj, eligible.obj=NULL, var.mod.obj)
}
%- maybe also `usage' for other objects documented here.
\arguments{
 \item{point.obj}{Object of class \code{"point"}, generated by
   \code{\link[sgeostat]{point}} from the \code{library(sgeostat)}. In the context 
   of spatial design for kriging this point object represents an existing
   network with \eqn{nf} stations. }
 \item{eligible.obj}{Object of class \code{"point"}, generated by
   \code{\link[sgeostat]{point}} from the \code{library(sgeostat)} representing the
   eligible points with \eqn{ne} stations in the context of spatial
   design for kriging, else it is NULL (default). }
 \item{var.mod.obj}{ Object of class \code{"variogram.model"} generated
   by \code{\link[sgeostat]{fit.variogram}} from the \code{library(sgeostat)}.  }
}
\value{
  Covariance matrix for the given point object(s).
}
\author{C. Gebhardt}

\seealso{ \code{\link[entropy]{make.matrix}}}

\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	     or do  help(data=index)  for the standard data sets.
}
\keyword{ spatial }%-- one or more ...
\keyword{ design }%-- one or more ...
